package meerkat.voting;

import com.google.protobuf.ByteString;
import meerkat.protobuf.Voting.*;

/**
 * Created by hai on 15/02/16.
 */
public class SystemConsoleOutputDevice implements BallotOutputDevice {

    /*
     * Returns the UTF8 decoding of byte-string data
     */
    private static String bytesToString(ByteString data) {
        return data.toStringUtf8();
    }

    @Override
    public void commitToBallot(long sessionId, EncryptedBallot encryptedBallot, VotingBooth.Callback callback) {

        System.out.println("Ballot #" + encryptedBallot.getSerialNumber() + ": "
                + bytesToString(encryptedBallot.getData().getData()));

        callback.ballotCommitResult(sessionId, true);

    }

    @Override
    public void audit(long sessionId, EncryptedBallot encryptedBallot, BallotSecrets ballotSecrets, VotingBooth.Callback callback) {

        //TODO: generate standard form for this
        System.out.println("Ballot #" + encryptedBallot.getSerialNumber() + ": "
                + bytesToString(encryptedBallot.getData().getData()));

        callback.ballotAuditResult(sessionId, true);

    }

    @Override
    public void castBallot(long sessionId, VotingBooth.Callback callback) {

        System.out.println("Ballot finalized!");

        callback.ballotCastResult(sessionId, true);

    }

    @Override
    public void cancelBallot(long sessionId, VotingBooth.Callback callback) {

        System.out.println("Ballot cancelled!");

        callback.ballotCancelResult(sessionId, true);

    }
}
